﻿Option Strict On

Imports Infragistics.Win
Imports Infragistics.Win.UltraWinTree

Public Class MainForm

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        Initialize()

    End Sub

    Private _IndexColumn As UltraTreeNodeColumn = Nothing
    Private _ValueColumn As UltraTreeNodeColumn = Nothing

    Private Sub Initialize()
        Dim rootColumnSet As UltraTreeColumnSet = uTree.ColumnSettings.RootColumnSet
        rootColumnSet.Columns.Clear()

        With uTree
            .DisplayStyle = UltraTreeDisplayStyle.WindowsVista
            .ViewStyle = ViewStyle.OutlookExpress
            .FullRowSelect = True
            .HideSelection = False
            .ExpansionIndicatorSize = New Size(0, 0)
            .ScrollBounds = ScrollBounds.ScrollToLastItem

            With .ColumnSettings
                .BorderStyleCell = UIElementBorderStyle.Solid
                .AutoFitColumns = AutoFitColumns.ResizeAllColumns
                .CellAppearance.BorderColor = SystemColors.Control
                .HeaderStyle = HeaderStyle.WindowsXPCommand
            End With
        End With


        _IndexColumn = rootColumnSet.Columns.Add("Index")
        With _IndexColumn
            .Text = "Index"
            .DataType = GetType(String)
            .LayoutInfo.PreferredCellSize = New Size(CInt(Me.Width / 2), 0)
            .AllowSorting = DefaultableBoolean.True
            .ShowSortIndicators = DefaultableBoolean.True
            .LayoutInfo.PreferredCellSize = New Size(0, 22)
        End With

        _ValueColumn = rootColumnSet.Columns.Add("Value")
        With _ValueColumn
            .Text = "Value"
            .DataType = GetType(String)
            .LayoutInfo.PreferredCellSize = New Size(CInt(Me.Width / 2), 0)
            .AllowSorting = DefaultableBoolean.True
            .ShowSortIndicators = DefaultableBoolean.True
            .LayoutInfo.PreferredCellSize = New Size(0, 22)
        End With

    End Sub


    Private Sub PopulateTrees()

        Dim rand As New Random


        With uTree
            .BeginUpdate()
            .Nodes.Clear()

            For i As Integer = 0 To 99
                Dim node As UltraTreeNode = uTree.Nodes.Add(i.ToString)
                node.SetCellValue(_IndexColumn, String.Format("{0:D3}", i))
                node.SetCellValue(_ValueColumn, rand.NextDouble.ToString)
            Next

            .EndUpdate()
        End With

        With Me.customTree
            .BeginUpdate()
            .Nodes.Clear()

            For i As Integer = 0 To 99
                .AddNode(String.Format("{0:D3}", i), rand.NextDouble.ToString)
            Next

            .EndUpdate()
        End With
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        PopulateTrees()
    End Sub

End Class
